#include <windows.h>
#include <stdio.h>
#include <string>
#include <vector>
using namespace std;

void GetModulePath(char *lpOutPath, char *lpInFileName)
{
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_PATH];
	char ext[_MAX_EXT];

	GetModuleFileName(NULL, lpOutPath, 256);
	_splitpath(lpOutPath, drive, dir, fname, ext );
	_makepath(lpOutPath, drive, dir, lpInFileName, "");
}

typedef  int (__stdcall *VeryPDFPDF2AnyConverterFunc)(const char *lpszCmdLine);
typedef void (__stdcall *VeryPDFPDF2AnySetCodeFunc)(const char *lpRegcode);
VeryPDFPDF2AnyConverterFunc lpVeryPDFPDF2AnyConverter = NULL;
VeryPDFPDF2AnySetCodeFunc   lpVeryPDFPDF2AnySetCode = NULL;
BOOL PDF2AnyConverterSDK(const char *lpszLicenseKey, const char *lpszCmdLine)
{
	if(lpszCmdLine == NULL || lpszCmdLine[0] == 0)
		return FALSE;

	char szPath[_MAX_PATH];
	GetModulePath(szPath,"pdf2anysdk.dll");
	HINSTANCE hPDF2AnySDK = LoadLibrary(szPath);
	if(hPDF2AnySDK == NULL)
		return FALSE;
	
	lpVeryPDFPDF2AnyConverter = (VeryPDFPDF2AnyConverterFunc)GetProcAddress(hPDF2AnySDK, "VeryPDFPDF2AnyConverter");
	if(lpVeryPDFPDF2AnyConverter == NULL)
		return FALSE;
	
	lpVeryPDFPDF2AnySetCode =(VeryPDFPDF2AnySetCodeFunc)GetProcAddress(hPDF2AnySDK, "VeryPDFPDF2AnySetCode");
	if(lpVeryPDFPDF2AnySetCode ==NULL)
		return FALSE;
	
	if(lpszLicenseKey && lpszLicenseKey[0] != 0)
		lpVeryPDFPDF2AnySetCode(lpszLicenseKey);
	int nResult = lpVeryPDFPDF2AnyConverter(lpszCmdLine);
	FreeLibrary(hPDF2AnySDK);
	return nResult;
}


std::wstring strtowstr(const std::string str)
{
    // Convert an ASCII string to a Unicode String
	int nLength = str.length()*2+1;
    std::wstring wstrTo;
    wchar_t *wszTo = new wchar_t[nLength];
    memset(wszTo, 0, sizeof(wchar_t)*nLength);
    MultiByteToWideChar(CP_ACP, 0, str.c_str(), -1, wszTo, (int)nLength);
    wstrTo = wszTo;
    delete[] wszTo;
    return wstrTo;
}

int main(int argc, char* argv[])
{
	if(argc == 1)
	{
		printf("Usage: [options] <in-file> [<out-file>]\n");
		return 0;
	}
	string strLicenseKey;
	char szCmdBuf[2048] = {0};
	for(int i = 1; i < argc; i++)
	{
		if(stricmp(argv[i], "-$") == 0)
		{
			strLicenseKey = argv[i+1];
			i++;
		}
		else
		{
			strcat(szCmdBuf, "\"");
			strcat(szCmdBuf, argv[i]);
			strcat(szCmdBuf, "\" ");
		}
	}

	int nRet = 0;
	nRet = PDF2AnyConverterSDK(strLicenseKey.c_str(), szCmdBuf);
	printf("nRet = %d\n",nRet);
	return nRet;
}
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
	LPTSTR lpCmdLine, int nCmdShow)
{
	return main(__argc,__argv);
}
